package jp.hishidama.swing.table.editor;

import java.awt.Color;
import java.awt.Component;
import java.text.DateFormat;
import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.swing.DefaultCellEditor;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.LineBorder;

/**
 * tGfB^[.
 *
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/tech/java/swing/JTable.html"
 *         >Ђ</a>
 * @since 2009.03.22
 */
public class DateEditor extends DefaultCellEditor {
	private static final long serialVersionUID = 7159257623625914894L;

	private DateFormat formatter;
	protected Date dvalue;

	/** RXgN^[. */
	public DateEditor() {
		super(new JTextField());
	}

	/**
	 * RXgN^[.
	 *
	 * @param pattern
	 *            tp^[
	 */
	public DateEditor(String pattern) {
		super(new JTextField());
		formatter = new SimpleDateFormat(pattern);
	}

	/**
	 * tH[}b^[ݒ.
	 *
	 * @param df
	 *            ttH[}b^[
	 */
	public void setFormatter(DateFormat df) {
		formatter = df;
	}

	/**
	 * tH[}b^[擾.
	 *
	 * @return ttH[}b^[
	 */
	public DateFormat getFormatter() {
		if (formatter == null) {
			formatter = DateFormat.getDateInstance();
			formatter.setLenient(false);
		}
		return formatter;
	}

	/**
	 * ҏWJnɌĂ΂
	 *
	 * @param table
	 *            Ώۃe[u
	 * @param value
	 *            ҏWΏۃf[^ilj
	 * @param isSelected
	 * @param row
	 *            f[^̂sԍ
	 * @param column
	 *            f[^̂ԍ
	 * @return `pR|[lg
	 */
	@Override
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int row, int column) {
		this.dvalue = null;
		((JComponent) getComponent()).setBorder(new LineBorder(Color.black));

		// row,columńATableColumnModel̑̌n
		// System.out.printf("getComponent(%b,%d,%d)+++%s %s%n", isSelected,
		// row, column, value.getClass(), value);

		DateFormat f = getFormatter();
		String str = (value == null) ? "" : f.format(value);
		return super.getTableCellEditorComponent(table, str, isSelected, row,
				column);
	}

	/**
	 * ҏWɌĂ΂.
	 * <p>
	 * super.stopCellEditing()ĂяoƐIƂȂB
	 * </p>
	 *
	 * @return truȅꍇAIiƎv邪Aۂɂ͉ԂĂ֌Wۂj
	 */
	@Override
	public boolean stopCellEditing() {
		Date d = null;

		String s = (String) super.getCellEditorValue();
		if (s != null && !s.isEmpty()) {
			DateFormat f = getFormatter();
			ParsePosition pos = new ParsePosition(0);
			d = f.parse(s, pos);
			if (pos.getErrorIndex() >= 0) {
				((JComponent) getComponent()).setBorder(new LineBorder(
						Color.red));
				return false;
			}
		}

		this.dvalue = d;
		return super.stopCellEditing();
	}

	/**
	 * ͂ꂽlԂ.
	 *
	 * @return ҏWꂽl
	 */
	@Override
	public Object getCellEditorValue() {
		return dvalue;
	}

	@Override
	public void cancelCellEditing() {
		// ǂ̃\bh͌Ă΂Ȃ͗l
		// System.out.println("cancelCellEditing:" + this);
		super.cancelCellEditing();
	}
}